import java.lang.reflect.Array;
import java.util.ArrayList;

public class SetArmoredCarsGeneric<T> {
    private T[] _places;

    public SetArmoredCarsGeneric(int count)
    {
        _places = (T[]) new Object[count];
    }

    public int getCount() {
        return _places != null ? _places.length : 0;
    }

    public int Insert(T armoredCar)
    {
        return Insert(armoredCar, 0);
    }

    public int Insert(T armoredCar, int position)
    {
        if (position < 0 || position >= getCount())
            return -1;

        if (!(_places[position] == null))
        {
            int index_empty = -1;
            // поиск первого пустого элемента
            for (int i = position + 1; i < getCount(); i++)
            {
                if (_places[i] == null)
                {
                    index_empty = i;
                }
            }
            if (index_empty == -1)
                return -1;
            else
            {
                for (int i = index_empty; i > position; i--)
                {
                    _places[i] = _places[i - 1];
                }
            }
        }
        _places[position] = armoredCar;
        return position;
    }

    public T Remove(int position)
    {
        if (position < 0 || position >= getCount())
            return null;
        T armoredCar = _places[position];
        _places[position] = null;
        return armoredCar;
    }

    public T Get(int position)
    {
        if (position < 0 || position >= getCount())
            return null;
        return _places[position];
    }
}
